#include <stdio.h>

#define READLINE

#ifdef TESTING
#define TESTING
 char s[BUFSIZ];
#else
 extern char s[];
#endif

static char bbuf2[BUFSIZ];

char *strchr();
char *strcpy();

char *readline(size,file)
int size;
FILE *file;
{
    char *rp;

    /*
    ** If first time through, fill s with read, else
    ** use line we previously read into bbuf2.
    */

    if (bbuf2[0] == '\0') {
       if (fgets(s,size,file) == NULL) 
           return(NULL);
    }
    else 
       (void) strcpy(s,bbuf2);

    if (fgets(bbuf2,size,file) == NULL) 
        return(NULL);

#ifdef DEBUG
printf("S = %s",s);
printf("bbuf2 = %s",bbuf2);
#endif

    /*
    ** If the next line starts with a whitespace, it is a continuation
    ** line and it must be concatinated to the previous line.
    */

    while(bbuf2[0] == ' ' || bbuf2[0] == '\t') {
#ifdef NOTDEF
       if ((rp = strchr(s,'\n')) != NULL)
            *rp = '\0';
#endif 
       rp = bbuf2;
#ifdef NOTDEF
       while(*rp && (*rp == ' ' || *rp == '\t')) 
           ++rp;
#endif

       if (strlen(s) + strlen(rp) < size)
           (void) sprintf(s,"%s%s", s, rp);

       if (fgets(bbuf2,size,file) == NULL) 
           return(NULL);
#ifdef DEBUG
printf("Concatenate S = [%s]\n",s);
printf("Reread bbuf2 = %s\n",bbuf2);
#endif
    }
    return (s);
}


#ifdef TESTING

main(argc,argv)
int argc;
char **argv;
{
    int cnt;
    char *pt;
    FILE *fp, *fopen();

    if (argc == 2) {
        if ((fp = fopen(argv[1], "r")) == NULL) {
            fprintf(stderr,"can't open %s\n", argv[1]);
            return(1);
        }

        cnt = 0;
        while ((pt = readline(BUFSIZ,fp)) != NULL) {
            (void) fprintf(stdout,"%s",pt);
            if (*pt == '\n') {
                if (++cnt >= 2)
                    break;
            }
        }
    }
    else 
        fprintf(stderr,"No file specified...\n");
    return(0);
}
#endif

